#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './mixminion.ui'
**
** Created: Sun Mar 9 17:58:20 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "mixminion.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "./mixminion.ui.h"

/*
 *  Constructs a MixMinionClient as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
MixMinionClient::MixMinionClient( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "MixMinionClient" );

    mailLayout = new QGroupBox( this, "mailLayout" );
    mailLayout->setGeometry( QRect( 11, 11, 578, 458 ) );
    mailLayout->setColumnLayout(0, Qt::Vertical );
    mailLayout->layout()->setSpacing( 6 );
    mailLayout->layout()->setMargin( 11 );
    mailLayoutLayout = new QGridLayout( mailLayout->layout() );
    mailLayoutLayout->setAlignment( Qt::AlignTop );

    layout2_2 = new QHBoxLayout( 0, 0, 6, "layout2_2"); 

    textLabel1_2 = new QLabel( mailLayout, "textLabel1_2" );
    layout2_2->addWidget( textLabel1_2 );

    subject = new QLineEdit( mailLayout, "subject" );
    subject->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, 0, 0, subject->sizePolicy().hasHeightForWidth() ) );
    layout2_2->addWidget( subject );

    mailLayoutLayout->addMultiCellLayout( layout2_2, 1, 1, 0, 1 );

    layout1 = new QHBoxLayout( 0, 0, 6, "layout1"); 
    spacer3 = new QSpacerItem( 461, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer3 );

    send = new QPushButton( mailLayout, "send" );
    send->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, send->sizePolicy().hasHeightForWidth() ) );
    layout1->addWidget( send );

    mailLayoutLayout->addMultiCellLayout( layout1, 4, 4, 0, 1 );

    messageBody = new QTextEdit( mailLayout, "messageBody" );

    mailLayoutLayout->addMultiCellWidget( messageBody, 2, 2, 0, 1 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    textLabel1 = new QLabel( mailLayout, "textLabel1" );
    layout2->addWidget( textLabel1 );

    toAddress = new QLineEdit( mailLayout, "toAddress" );
    toAddress->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, 0, 0, toAddress->sizePolicy().hasHeightForWidth() ) );
    layout2->addWidget( toAddress );

    mailLayoutLayout->addMultiCellLayout( layout2, 0, 0, 0, 1 );
    languageChange();
    resize( QSize(600, 480).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( send, SIGNAL( clicked() ), this, SLOT( send_clicked() ) );

    // tab order
    setTabOrder( toAddress, subject );
    setTabOrder( subject, messageBody );
    setTabOrder( messageBody, send );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
MixMinionClient::~MixMinionClient()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void MixMinionClient::languageChange()
{
    setCaption( tr2i18n( "Anonymous Email Message" ) );
    mailLayout->setTitle( tr2i18n( "Anonymous Email Message For Delivery Through the Mixminion Network" ) );
    textLabel1_2->setText( tr2i18n( "Subject:" ) );
    send->setText( tr2i18n( "Send" ) );
    textLabel1->setText( tr2i18n( "To:" ) );
}

#include "mixminion.moc"
