#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './server.ui'
**
** Created: Sun Mar 9 17:58:20 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "server.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qheader.h>
#include <qlistview.h>
#include <qspinbox.h>
#include <qframe.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "./server.ui.h"

/*
 *  Constructs a MyServer as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
MyServer::MyServer( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "MyServer" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setSizeGripEnabled( FALSE );
    MyServerLayout = new QGridLayout( this, 1, 1, 11, 6, "MyServerLayout"); 

    tabWidget = new QTabWidget( this, "tabWidget" );
    tabWidget->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, tabWidget->sizePolicy().hasHeightForWidth() ) );

    Widget8 = new QWidget( tabWidget, "Widget8" );
    Widget8Layout = new QGridLayout( Widget8, 1, 1, 11, 6, "Widget8Layout"); 

    kcfg_ClientOnly = new QCheckBox( Widget8, "kcfg_ClientOnly" );

    Widget8Layout->addWidget( kcfg_ClientOnly, 0, 0 );

    ServerInfo = new QGroupBox( Widget8, "ServerInfo" );
    ServerInfo->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 0, 0, ServerInfo->sizePolicy().hasHeightForWidth() ) );
    ServerInfo->setColumnLayout(0, Qt::Vertical );
    ServerInfo->layout()->setSpacing( 6 );
    ServerInfo->layout()->setMargin( 11 );
    ServerInfoLayout = new QGridLayout( ServerInfo->layout() );
    ServerInfoLayout->setAlignment( Qt::AlignTop );

    layout1 = new QGridLayout( 0, 1, 1, 0, 6, "layout1"); 

    kcfg_NickName = new QLineEdit( ServerInfo, "kcfg_NickName" );
    kcfg_NickName->setMaxLength( 20 );

    layout1->addWidget( kcfg_NickName, 0, 1 );

    kcfg_ContactInfo = new QLineEdit( ServerInfo, "kcfg_ContactInfo" );
    kcfg_ContactInfo->setMaxLength( 40 );

    layout1->addWidget( kcfg_ContactInfo, 0, 3 );

    textLabel1 = new QLabel( ServerInfo, "textLabel1" );

    layout1->addWidget( textLabel1, 0, 2 );

    textLabel1_2 = new QLabel( ServerInfo, "textLabel1_2" );

    layout1->addWidget( textLabel1_2, 0, 0 );

    ServerInfoLayout->addMultiCellLayout( layout1, 0, 0, 0, 1 );

    layout2 = new QGridLayout( 0, 1, 1, 0, 6, "layout2"); 

    MyFamily = new QListView( ServerInfo, "MyFamily" );
    MyFamily->addColumn( tr2i18n( "CC" ) );
    MyFamily->addColumn( tr2i18n( "geoip" ) );
    MyFamily->addColumn( tr2i18n( "fp" ) );
    MyFamily->addColumn( tr2i18n( "My Family       " ) );
    MyFamily->header()->setResizeEnabled( FALSE, MyFamily->header()->count() - 1 );
    MyFamily->setSelectionMode( QListView::Extended );
    MyFamily->setAllColumnsShowFocus( TRUE );
    MyFamily->setResizeMode( QListView::AllColumns );

    layout2->addWidget( MyFamily, 0, 1 );

    pushButton2 = new QPushButton( ServerInfo, "pushButton2" );

    layout2->addWidget( pushButton2, 1, 1 );

    textLabel7_2_2_2_3 = new QLabel( ServerInfo, "textLabel7_2_2_2_3" );

    layout2->addMultiCellWidget( textLabel7_2_2_2_3, 0, 1, 0, 0 );

    ServerInfoLayout->addMultiCellLayout( layout2, 1, 1, 0, 1 );

    layout5 = new QGridLayout( 0, 1, 1, 0, 6, "layout5"); 

    kcfg_DirListenAddress = new QSpinBox( ServerInfo, "kcfg_DirListenAddress" );
    kcfg_DirListenAddress->setEnabled( TRUE );
    kcfg_DirListenAddress->setMaxValue( 9999 );

    layout5->addWidget( kcfg_DirListenAddress, 1, 1 );

    textLabel4 = new QLabel( ServerInfo, "textLabel4" );

    layout5->addWidget( textLabel4, 0, 0 );

    kcfg_ORListenAddress = new QSpinBox( ServerInfo, "kcfg_ORListenAddress" );
    kcfg_ORListenAddress->setEnabled( TRUE );
    kcfg_ORListenAddress->setMaxValue( 9999 );

    layout5->addWidget( kcfg_ORListenAddress, 0, 1 );

    textLabel4_2 = new QLabel( ServerInfo, "textLabel4_2" );

    layout5->addWidget( textLabel4_2, 1, 0 );

    ServerInfoLayout->addLayout( layout5, 3, 0 );

    kcfg_ForwardPorts = new QCheckBox( ServerInfo, "kcfg_ForwardPorts" );

    ServerInfoLayout->addWidget( kcfg_ForwardPorts, 3, 1 );

    layout4 = new QVBoxLayout( 0, 0, 6, "layout4"); 

    line1_2 = new QFrame( ServerInfo, "line1_2" );
    line1_2->setFrameShape( QFrame::HLine );
    line1_2->setFrameShadow( QFrame::Sunken );
    line1_2->setFrameShape( QFrame::HLine );
    layout4->addWidget( line1_2 );

    kcfg_PublishServerDescriptor = new QCheckBox( ServerInfo, "kcfg_PublishServerDescriptor" );
    layout4->addWidget( kcfg_PublishServerDescriptor );

    line1_2_2 = new QFrame( ServerInfo, "line1_2_2" );
    line1_2_2->setFrameShape( QFrame::HLine );
    line1_2_2->setFrameShadow( QFrame::Sunken );
    line1_2_2->setFrameShape( QFrame::HLine );
    layout4->addWidget( line1_2_2 );

    kcfg_MiddleMan = new QCheckBox( ServerInfo, "kcfg_MiddleMan" );
    layout4->addWidget( kcfg_MiddleMan );

    kcfg_BridgeRelay = new QCheckBox( ServerInfo, "kcfg_BridgeRelay" );
    layout4->addWidget( kcfg_BridgeRelay );

    ServerInfoLayout->addMultiCellLayout( layout4, 4, 4, 0, 1 );

    line1 = new QFrame( ServerInfo, "line1" );
    line1->setFrameShape( QFrame::HLine );
    line1->setFrameShadow( QFrame::Sunken );
    line1->setFrameShape( QFrame::HLine );

    ServerInfoLayout->addMultiCellWidget( line1, 2, 2, 0, 1 );

    Widget8Layout->addWidget( ServerInfo, 1, 0 );
    tabWidget->insertTab( Widget8, QString::fromLatin1("") );

    TabPage = new QWidget( tabWidget, "TabPage" );
    TabPageLayout = new QGridLayout( TabPage, 1, 1, 11, 6, "TabPageLayout"); 

    kcfg_DefaultServerPerformance = new QCheckBox( TabPage, "kcfg_DefaultServerPerformance" );
    kcfg_DefaultServerPerformance->setChecked( TRUE );

    TabPageLayout->addWidget( kcfg_DefaultServerPerformance, 0, 0 );

    line3 = new QFrame( TabPage, "line3" );
    line3->setFrameShape( QFrame::HLine );
    line3->setFrameShadow( QFrame::Sunken );
    line3->setFrameShape( QFrame::HLine );

    TabPageLayout->addWidget( line3, 1, 0 );
    spacer1 = new QSpacerItem( 21, 240, QSizePolicy::Minimum, QSizePolicy::Expanding );
    TabPageLayout->addItem( spacer1, 3, 0 );

    PerformanceOptions = new QGroupBox( TabPage, "PerformanceOptions" );
    PerformanceOptions->setEnabled( FALSE );
    PerformanceOptions->setColumnLayout(0, Qt::Vertical );
    PerformanceOptions->layout()->setSpacing( 6 );
    PerformanceOptions->layout()->setMargin( 11 );
    PerformanceOptionsLayout = new QGridLayout( PerformanceOptions->layout() );
    PerformanceOptionsLayout->setAlignment( Qt::AlignTop );

    kcfg_NumCPUs = new QSpinBox( PerformanceOptions, "kcfg_NumCPUs" );
    kcfg_NumCPUs->setMaxValue( 5000 );
    kcfg_NumCPUs->setValue( 1 );

    PerformanceOptionsLayout->addWidget( kcfg_NumCPUs, 0, 4 );

    kcfg_MaxOnionsPending = new QSpinBox( PerformanceOptions, "kcfg_MaxOnionsPending" );
    kcfg_MaxOnionsPending->setMaxValue( 5000 );
    kcfg_MaxOnionsPending->setValue( 100 );

    PerformanceOptionsLayout->addWidget( kcfg_MaxOnionsPending, 1, 4 );

    textLabel2_2 = new QLabel( PerformanceOptions, "textLabel2_2" );

    PerformanceOptionsLayout->addMultiCellWidget( textLabel2_2, 1, 1, 0, 3 );

    textLabel2 = new QLabel( PerformanceOptions, "textLabel2" );

    PerformanceOptionsLayout->addMultiCellWidget( textLabel2, 0, 0, 0, 3 );

    textLabel3 = new QLabel( PerformanceOptions, "textLabel3" );

    PerformanceOptionsLayout->addMultiCellWidget( textLabel3, 2, 2, 2, 3 );

    textLabel3_2 = new QLabel( PerformanceOptions, "textLabel3_2" );

    PerformanceOptionsLayout->addMultiCellWidget( textLabel3_2, 3, 3, 0, 2 );

    kcfg_ShutDownWaitLength = new QSpinBox( PerformanceOptions, "kcfg_ShutDownWaitLength" );
    kcfg_ShutDownWaitLength->setMaxValue( 5000 );

    PerformanceOptionsLayout->addMultiCellWidget( kcfg_ShutDownWaitLength, 3, 3, 3, 4 );

    AccountingStart = new QComboBox( FALSE, PerformanceOptions, "AccountingStart" );

    PerformanceOptionsLayout->addWidget( AccountingStart, 2, 4 );

    kcfg_AccountingMax = new QSpinBox( PerformanceOptions, "kcfg_AccountingMax" );

    PerformanceOptionsLayout->addWidget( kcfg_AccountingMax, 2, 1 );

    textLabel2_2_2 = new QLabel( PerformanceOptions, "textLabel2_2_2" );

    PerformanceOptionsLayout->addWidget( textLabel2_2_2, 2, 0 );

    kcfg_ConnLimit = new QSpinBox( PerformanceOptions, "kcfg_ConnLimit" );
    kcfg_ConnLimit->setMaxValue( 9999 );

    PerformanceOptionsLayout->addMultiCellWidget( kcfg_ConnLimit, 4, 4, 3, 4 );

    textLabel4_2_2_2 = new QLabel( PerformanceOptions, "textLabel4_2_2_2" );

    PerformanceOptionsLayout->addMultiCellWidget( textLabel4_2_2_2, 4, 4, 0, 2 );

    TabPageLayout->addWidget( PerformanceOptions, 2, 0 );
    tabWidget->insertTab( TabPage, QString::fromLatin1("") );

    ExitPolicies = new QWidget( tabWidget, "ExitPolicies" );
    ExitPoliciesLayout = new QGridLayout( ExitPolicies, 1, 1, 11, 6, "ExitPoliciesLayout"); 
    spacer2 = new QSpacerItem( 20, 130, QSizePolicy::Minimum, QSizePolicy::Expanding );
    ExitPoliciesLayout->addItem( spacer2, 1, 0 );

    groupBox6 = new QGroupBox( ExitPolicies, "groupBox6" );
    groupBox6->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, groupBox6->sizePolicy().hasHeightForWidth() ) );
    groupBox6->setColumnLayout(0, Qt::Vertical );
    groupBox6->layout()->setSpacing( 6 );
    groupBox6->layout()->setMargin( 11 );
    groupBox6Layout = new QGridLayout( groupBox6->layout() );
    groupBox6Layout->setAlignment( Qt::AlignTop );

    textLabel5_2 = new QLabel( groupBox6, "textLabel5_2" );

    groupBox6Layout->addMultiCellWidget( textLabel5_2, 0, 1, 0, 0 );

    ExitPolicy = new QListView( groupBox6, "ExitPolicy" );
    ExitPolicy->addColumn( tr2i18n( "Policy" ) );
    ExitPolicy->addColumn( tr2i18n( "IP Address        " ) );
    ExitPolicy->header()->setResizeEnabled( FALSE, ExitPolicy->header()->count() - 1 );
    ExitPolicy->addColumn( tr2i18n( "Port" ) );
    ExitPolicy->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, ExitPolicy->sizePolicy().hasHeightForWidth() ) );
    ExitPolicy->setSelectionMode( QListView::Extended );
    ExitPolicy->setAllColumnsShowFocus( FALSE );
    ExitPolicy->setResizeMode( QListView::AllColumns );

    groupBox6Layout->addMultiCellWidget( ExitPolicy, 0, 0, 1, 4 );

    SocksPort = new QSpinBox( groupBox6, "SocksPort" );

    groupBox6Layout->addWidget( SocksPort, 1, 3 );

    PushAdd2 = new QPushButton( groupBox6, "PushAdd2" );

    groupBox6Layout->addWidget( PushAdd2, 1, 4 );

    Policy = new QComboBox( FALSE, groupBox6, "Policy" );

    groupBox6Layout->addWidget( Policy, 1, 1 );

    SocksAddress = new QLineEdit( groupBox6, "SocksAddress" );

    groupBox6Layout->addWidget( SocksAddress, 1, 2 );

    ExitPoliciesLayout->addWidget( groupBox6, 0, 0 );
    tabWidget->insertTab( ExitPolicies, QString::fromLatin1("") );

    MyServerLayout->addWidget( tabWidget, 0, 0 );
    languageChange();
    resize( QSize(532, 513).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( kcfg_DefaultServerPerformance, SIGNAL( toggled(bool) ), this, SLOT( checkBox6_toggled(bool) ) );
    connect( kcfg_MiddleMan, SIGNAL( toggled(bool) ), this, SLOT( kcfg_MiddleMan_toggled(bool) ) );
    connect( PushAdd2, SIGNAL( clicked() ), this, SLOT( pushAdd2_clicked() ) );
    connect( ExitPolicy, SIGNAL( contextMenuRequested(QListViewItem*,const QPoint&,int) ), this, SLOT( ExitPolicy_contextMenuRequested(QListViewItem*,const QPoint&,int) ) );
    connect( pushButton2, SIGNAL( clicked() ), this, SLOT( pushButton2_clicked() ) );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
MyServer::~MyServer()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void MyServer::languageChange()
{
    setCaption( tr2i18n( "MyDialog1" ) );
    kcfg_ClientOnly->setText( tr2i18n( "Never Run As a Server, &Even If Tor Thinks I've Got The Girth" ) );
    kcfg_ClientOnly->setAccel( QKeySequence( tr2i18n( "Alt+E" ) ) );
    ServerInfo->setTitle( tr2i18n( "Tor Server Details" ) );
    textLabel1->setText( tr2i18n( "Contact Info:" ) );
    textLabel1_2->setText( tr2i18n( "Nick:" ) );
    MyFamily->header()->setLabel( 0, tr2i18n( "CC" ) );
    MyFamily->header()->setLabel( 1, tr2i18n( "geoip" ) );
    MyFamily->header()->setLabel( 2, tr2i18n( "fp" ) );
    MyFamily->header()->setLabel( 3, tr2i18n( "My Family       " ) );
    pushButton2->setText( tr2i18n( "Delete Selected" ) );
    textLabel7_2_2_2_3->setText( tr2i18n( "<p> This is a list of other servers that you administer. This will prevent people from using you more than once.\n"
"<p><b>You add to this list by right-clicking on your servers in the main 'Tor Network' tab and clicking 'Add to My Family'.</b></p>" ) );
    textLabel4->setText( tr2i18n( "Serve Tor Traffic on Local Port" ) );
    textLabel4_2->setText( tr2i18n( "Serve Tor Listings on Local Port" ) );
    kcfg_ForwardPorts->setText( tr2i18n( "Improve Accessibility" ) );
    QToolTip::add( kcfg_ForwardPorts, tr2i18n( "This will tell Tor to adverise your Tor server on the common ports 80 and 443, <br> it will also tell your router to forward traffic on these ports to Tor." ) );
    kcfg_PublishServerDescriptor->setText( tr2i18n( "Let the Tor Network know about me as a server" ) );
    kcfg_PublishServerDescriptor->setAccel( QKeySequence( QString::null ) );
    kcfg_MiddleMan->setText( tr2i18n( "&Act as a Relay Server Only (Disables Your Exit Policies in the Tab Above)." ) );
    kcfg_MiddleMan->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    kcfg_BridgeRelay->setText( tr2i18n( "&Act as an Anti-Censorship Relay" ) );
    kcfg_BridgeRelay->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    tabWidget->changeTab( Widget8, tr2i18n( "&General" ) );
    kcfg_DefaultServerPerformance->setText( tr2i18n( "Let Tor figure out the &best performance options to use" ) );
    kcfg_DefaultServerPerformance->setAccel( QKeySequence( tr2i18n( "Alt+B" ) ) );
    PerformanceOptions->setTitle( tr2i18n( "Performance Options" ) );
    textLabel2_2->setText( tr2i18n( "Maximum number of encryption tasks to keep waiting:" ) );
    textLabel2->setText( tr2i18n( "Maximum number of simultaneous encryption tasks:" ) );
    textLabel3->setText( tr2i18n( "every" ) );
    textLabel3_2->setText( tr2i18n( "When shutting down, wait at most: " ) );
    kcfg_ShutDownWaitLength->setSuffix( tr2i18n( " seconds" ) );
    AccountingStart->clear();
    AccountingStart->insertItem( tr2i18n( "day" ) );
    AccountingStart->insertItem( tr2i18n( "week" ) );
    AccountingStart->insertItem( tr2i18n( "month" ) );
    kcfg_AccountingMax->setSuffix( tr2i18n( " MBs p/s" ) );
    textLabel2_2_2->setText( tr2i18n( "Never exceed " ) );
    kcfg_ConnLimit->setSuffix( tr2i18n( " descriptors" ) );
    textLabel4_2_2_2->setText( tr2i18n( "Do not start unless system can support at least" ) );
    tabWidget->changeTab( TabPage, tr2i18n( "&Performance" ) );
    groupBox6->setTitle( tr2i18n( "Sites you do not want to send traffic to" ) );
    textLabel5_2->setText( tr2i18n( "<p> When you are an exit server for a circuit it is your computer that the destination website or host will see - the traffic will have your name on it. If you are an exit server and do not want your server to route traffic to certain sites/hosts this is the place to specify them.</p>\n"
"<p><b>Use '0' as the port to specify 'all ports'. Use '*' as the address to specify 'all addresses'</b>.</p>" ) );
    ExitPolicy->header()->setLabel( 0, tr2i18n( "Policy" ) );
    ExitPolicy->header()->setLabel( 1, tr2i18n( "IP Address        " ) );
    ExitPolicy->header()->setLabel( 2, tr2i18n( "Port" ) );
    PushAdd2->setText( tr2i18n( "O&K" ) );
    PushAdd2->setAccel( QKeySequence( tr2i18n( "Alt+K" ) ) );
    Policy->clear();
    Policy->insertItem( tr2i18n( "accept" ) );
    Policy->insertItem( tr2i18n( "reject" ) );
    tabWidget->changeTab( ExitPolicies, tr2i18n( "&Exit Policies" ) );
}

#include "server.moc"
