/****************************************************************************
** Form interface generated from reading ui file './torkview_base.ui'
**
** Created: Sun Mar 9 17:58:20 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef TORKVIEW_BASE_H
#define TORKVIEW_BASE_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qwidget.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class DndListView;
class KWidgetListbox;
class QFrame;
class QLabel;
class QTabWidget;
class QSplitter;
class QGroupBox;
class KListViewSearchLine;
class QToolButton;
class QListView;
class QListViewItem;
class QPushButton;
class QCheckBox;
class QSpinBox;

class torkview_base : public QWidget
{
    Q_OBJECT

public:
    torkview_base( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~torkview_base();

    QFrame* frame4;
    QLabel* textLabel2;
    QLabel* textLabel1_2;
    QFrame* frame5;
    QLabel* textLabel3;
    QFrame* ChartFrame;
    QTabWidget* TorkTabs;
    QWidget* Anonymize;
    KWidgetListbox* Anonymizer;
    QWidget* TorNetwork;
    QSplitter* splitter5;
    QGroupBox* Network;
    DndListView* serverList;
    KListViewSearchLine* serverFilter;
    QToolButton* clearButton;
    QSplitter* splitter4;
    QGroupBox* groupBox2;
    DndListView* streamList;
    QSplitter* splitter3;
    QGroupBox* groupBox1;
    DndListView* circuitList;
    QGroupBox* groupBox3;
    DndListView* ORList;
    QWidget* TorLog;
    QListView* infoList;
    QPushButton* clearInfo;
    QCheckBox* ShowHostNames;
    QWidget* TrafficLog;
    QSplitter* splitter4_2;
    QGroupBox* groupBox5;
    QListView* TorTraffic;
    QPushButton* clearTorTraffic;
    QGroupBox* groupBox6;
    QPushButton* clearNonTorTraffic;
    QListView* NonTorTraffic;
    QSpinBox* NonTorTrafficMaxEntries;
    QLabel* textLabel1;
    QCheckBox* kcfg_LogNonTorTraffic;
    QCheckBox* kcfg_LogTorTraffic;

public slots:
    virtual void stopDisplayingBubble(QListViewItem*,const QPoint&,int);
    virtual void streamList_contextMenuRequested( QListViewItem *, const QPoint & point, int );
    virtual void slotAttachStreams();
    virtual void slotCloseStream();
    virtual void circuitList_contextMenuRequested( QListViewItem *, const QPoint & point, int );
    virtual void slotCloseCircuit();
    virtual void serverList_contextMenuRequested( QListViewItem *, const QPoint & point, int );
    virtual void slotClearNodes();
    virtual void slotAddToFamily();
    virtual void slotAddPermExcludeCountry();
    virtual void slotAddPermExcludeNodes();
    virtual void slotAddSessionExcludeCountry();
    virtual void slotAddSessionExcludeNodes();
    virtual void slotAddPermExitNodes();
    virtual void slotAddPermStrictExitNodes();
    virtual void slotAddSessionExitNodes();
    virtual void slotAddSessionStrictExitNodes();
    virtual void slotAddPermEntryNodes();
    virtual void slotAddSessionEntryNodes();
    virtual void addExcludeNodes( bool perm, QStringList ccs );
    virtual void clearInfo_clicked();
    virtual void clearTorTraffic_clicked();
    virtual void clearNonTorTraffic_clicked();
    virtual void NonTorTrafficMaxEntries_valueChanged( int newval );
    virtual void useNewIdentity_clicked( int, int );
    virtual void useKonqWithTor_clicked( int, int );
    virtual void viewNetworkList_clicked( int, int );
    virtual void viewHiddenServices_clicked( int, int );
    virtual void kcfg_LogNonTorTraffic_toggled( bool state );
    virtual void kcfg_LogTorTraffic_toggled( bool state );
    virtual void ShowHostNames_toggled( bool safe );

signals:
    void closeStream(const QString &);
    void closeCircuit(const QString &);
    void closeAllCircuits( QListView* &);
    void copyOldConfig( );
    void attachStreams(bool);
    void newIdentity();
    void konqWithTor();
    void networkList();
    void hiddenServices();
    void toggleTorTraffic(bool);
    void toggleNonTorTraffic(bool);
    void updateExcludeNodes();
    void updateEntryNodes();
    void updateExitNodes();
    void clearNodes();
    void updateStrictExitNodes(bool);
    void safeLogging(bool);

protected:
    QGridLayout* torkview_baseLayout;
    QGridLayout* AnonymizeLayout;
    QGridLayout* TorNetworkLayout;
    QGridLayout* NetworkLayout;
    QGridLayout* groupBox2Layout;
    QGridLayout* groupBox1Layout;
    QHBoxLayout* groupBox3Layout;
    QGridLayout* TorLogLayout;
    QSpacerItem* spacer1;
    QGridLayout* TrafficLogLayout;
    QGridLayout* groupBox5Layout;
    QSpacerItem* spacer2;
    QGridLayout* groupBox6Layout;
    QSpacerItem* spacer2_2;

protected slots:
    virtual void languageChange();

private:
    QPixmap image0;
    QPixmap image1;
    QPixmap image2;
    QPixmap image3;

    void init();
    QStringList selectByCountry();
    void addEntryNodes( bool perm );
    void addExitNodes( bool perm, bool strict );

};

#endif // TORKVIEW_BASE_H
