#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './serverwizard.ui'
**
** Created: Sun Mar 9 17:58:20 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "serverwizard.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "./serverwizard.ui.h"

/*
 *  Constructs a ServerWizard as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The wizard will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal wizard.
 */
ServerWizard::ServerWizard( QWidget* parent, const char* name, bool modal, WFlags fl )
    : KWizard( parent, name, modal, fl )
{
    if ( !name )
	setName( "ServerWizard" );

    ServerName = new QWidget( this, "ServerName" );
    ServerNameLayout = new QGridLayout( ServerName, 1, 1, 11, 6, "ServerNameLayout"); 

    groupBox1 = new QGroupBox( ServerName, "groupBox1" );
    groupBox1->setColumnLayout(0, Qt::Vertical );
    groupBox1->layout()->setSpacing( 6 );
    groupBox1->layout()->setMargin( 11 );
    groupBox1Layout = new QGridLayout( groupBox1->layout() );
    groupBox1Layout->setAlignment( Qt::AlignTop );

    textLabel1 = new QLabel( groupBox1, "textLabel1" );

    groupBox1Layout->addMultiCellWidget( textLabel1, 0, 0, 0, 1 );

    textLabel2 = new QLabel( groupBox1, "textLabel2" );

    groupBox1Layout->addWidget( textLabel2, 2, 0 );

    serverName = new QLineEdit( groupBox1, "serverName" );

    groupBox1Layout->addWidget( serverName, 2, 1 );
    spacer1 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    groupBox1Layout->addItem( spacer1, 1, 1 );

    ServerNameLayout->addWidget( groupBox1, 0, 0 );
    addPage( ServerName, QString("") );

    ContactInfo = new QWidget( this, "ContactInfo" );
    ContactInfoLayout = new QGridLayout( ContactInfo, 1, 1, 11, 6, "ContactInfoLayout"); 

    groupBox1_2 = new QGroupBox( ContactInfo, "groupBox1_2" );
    groupBox1_2->setColumnLayout(0, Qt::Vertical );
    groupBox1_2->layout()->setSpacing( 6 );
    groupBox1_2->layout()->setMargin( 11 );
    groupBox1_2Layout = new QGridLayout( groupBox1_2->layout() );
    groupBox1_2Layout->setAlignment( Qt::AlignTop );

    textLabel1_2 = new QLabel( groupBox1_2, "textLabel1_2" );

    groupBox1_2Layout->addMultiCellWidget( textLabel1_2, 0, 0, 0, 1 );

    contactMail = new QLineEdit( groupBox1_2, "contactMail" );

    groupBox1_2Layout->addWidget( contactMail, 2, 1 );

    textLabel2_2 = new QLabel( groupBox1_2, "textLabel2_2" );

    groupBox1_2Layout->addWidget( textLabel2_2, 2, 0 );
    spacer2 = new QSpacerItem( 20, 31, QSizePolicy::Minimum, QSizePolicy::Expanding );
    groupBox1_2Layout->addItem( spacer2, 1, 1 );

    ContactInfoLayout->addWidget( groupBox1_2, 0, 0 );
    addPage( ContactInfo, QString("") );

    ServerReachability = new QWidget( this, "ServerReachability" );
    ServerReachabilityLayout = new QGridLayout( ServerReachability, 1, 1, 11, 6, "ServerReachabilityLayout"); 

    groupBox1_2_2 = new QGroupBox( ServerReachability, "groupBox1_2_2" );
    groupBox1_2_2->setColumnLayout(0, Qt::Vertical );
    groupBox1_2_2->layout()->setSpacing( 6 );
    groupBox1_2_2->layout()->setMargin( 11 );
    groupBox1_2_2Layout = new QGridLayout( groupBox1_2_2->layout() );
    groupBox1_2_2Layout->setAlignment( Qt::AlignTop );

    textLabel1_2_2 = new QLabel( groupBox1_2_2, "textLabel1_2_2" );

    groupBox1_2_2Layout->addWidget( textLabel1_2_2, 0, 0 );

    buttonGroup1 = new QButtonGroup( groupBox1_2_2, "buttonGroup1" );
    buttonGroup1->setColumnLayout(0, Qt::Vertical );
    buttonGroup1->layout()->setSpacing( 6 );
    buttonGroup1->layout()->setMargin( 11 );
    buttonGroup1Layout = new QGridLayout( buttonGroup1->layout() );
    buttonGroup1Layout->setAlignment( Qt::AlignTop );

    ForwardPorts = new QCheckBox( buttonGroup1, "ForwardPorts" );

    buttonGroup1Layout->addWidget( ForwardPorts, 0, 0 );

    RoutersFound = new QLabel( buttonGroup1, "RoutersFound" );
    RoutersFound->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );

    buttonGroup1Layout->addWidget( RoutersFound, 1, 0 );

    groupBox1_2_2Layout->addWidget( buttonGroup1, 1, 0 );

    ServerReachabilityLayout->addWidget( groupBox1_2_2, 0, 0 );
    addPage( ServerReachability, QString("") );
    languageChange();
    resize( QSize(416, 329).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
ServerWizard::~ServerWizard()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ServerWizard::languageChange()
{
    setCaption( tr2i18n( "Tor Server Guide" ) );
    groupBox1->setTitle( tr2i18n( "Server Name" ) );
    textLabel1->setText( tr2i18n( "<p>By running a Tor server you will allow users of the Tor network to route their traffic through your computer. Running a Tor server does not affect your own anonymity while using Tor.</p>\n"
"<p>Every Tor server has a nickname, for easy identification. It's not that important what you call it.</p>" ) );
    textLabel2->setText( tr2i18n( "Server NickName:" ) );
    setTitle( ServerName, tr2i18n( "Naming your Tor Server" ) );
    groupBox1_2->setTitle( tr2i18n( "Contact Information" ) );
    textLabel1_2->setText( tr2i18n( "<p>In case you inadvertently mis-configure your server, other operators or the Tor team may want to contact you so you can correct any issues..</p>\n"
"<p>You are not obliged to provide a contact email, but it will certainly help in the event of a problem.</p>" ) );
    textLabel2_2->setText( tr2i18n( "Your email:" ) );
    setTitle( ContactInfo, tr2i18n( "In Case There's a Problem" ) );
    groupBox1_2_2->setTitle( tr2i18n( "Opening Up Your Router For Tor Users" ) );
    textLabel1_2_2->setText( tr2i18n( "<p>Most Tor users can access the internet over ports 80 (http://) and 443 (https://). It will help if these are the ports Tor advertises to them.</p>\n"
"<p>If you want, TorK can contact your router and tell it to ensure anything that arrives on ports 80 and 443 is sent to Tor. If you'd like to do this, tick the box below if it is enabled..</p>" ) );
    buttonGroup1->setTitle( tr2i18n( "Server Accessibility" ) );
    ForwardPorts->setText( tr2i18n( "Make Tor Easily Accessible." ) );
    RoutersFound->setText( tr2i18n( "<b>No Routers Found. Check your local firewall and ensure your router has UPnP enabled.</b>" ) );
    setTitle( ServerReachability, tr2i18n( "Making Your Server Reachable" ) );
}

#include "serverwizard.moc"
